﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Telerik.WinControls.Data;
using Telerik.WinControls.UI;

namespace RadComboBoxUpwards
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

            RadMultiColumnComboBoxElement multiColumnComboElement = this.radMultiColumnComboBox1.MultiColumnComboBoxElement; 
            GridViewTextBoxColumn column = new GridViewTextBoxColumn("CustomerID"); 
            column.HeaderText = "Customer ID"; 
            multiColumnComboElement.Columns.Add(column);
            
            column = new GridViewTextBoxColumn("ContactName"); 
            column.HeaderText = "Contact Name"; 
            multiColumnComboElement.Columns.Add(column); 
            column = new GridViewTextBoxColumn("ContactTitle"); 
            column.HeaderText = "Contact Title"; 
            multiColumnComboElement.Columns.Add(column); 
            column = new GridViewTextBoxColumn("Country"); 
            column.HeaderText = "Country"; 
            multiColumnComboElement.Columns.Add(column); 
            column = new GridViewTextBoxColumn("Phone"); 
            column.HeaderText = "Phone"; 
            multiColumnComboElement.Columns.Add(column);
            for (int i = 0; i < 100; i++)
            {
                multiColumnComboElement.Rows.Add(i);
            }

            this.radMultiColumnComboBox1.AutoFilter = true;
            FilterDescriptor filter = new FilterDescriptor();
            filter.PropertyName = this.radMultiColumnComboBox1.DisplayMember;
            filter.Operator = FilterOperator.Contains;
            this.radMultiColumnComboBox1.EditorControl.MasterTemplate.FilterDescriptors.Add(filter);

            radMultiColumnComboBox1.MultiColumnComboBoxElement.MultiColumnPopupForm.PopupOpening += MultiColumnPopupForm_PopupOpening;
            radMultiColumnComboBox1.MultiColumnComboBoxElement.EditorControl.FilterChanged += EditorControl_FilterChanged;
            radMultiColumnComboBox1.AutoSizeDropDownToBestFit = true;
        }

        void EditorControl_FilterChanged(object sender, GridViewCollectionChangedEventArgs e)
        {
            Point mccbScreenLocation = this.PointToScreen(radMultiColumnComboBox1.Location);
            mccbScreenLocation.Y = mccbScreenLocation.Y - radMultiColumnComboBox1.MultiColumnComboBoxElement.MultiColumnPopupForm.Height;
            radMultiColumnComboBox1.MultiColumnComboBoxElement.MultiColumnPopupForm.Location = mccbScreenLocation;
        }

        void MultiColumnPopupForm_PopupOpening(object sender, CancelEventArgs args)
        {
            Point mccbScreenLocation = this.PointToScreen(radMultiColumnComboBox1.Location);
            mccbScreenLocation.Y = mccbScreenLocation.Y - radMultiColumnComboBox1.MultiColumnComboBoxElement.MultiColumnPopupForm.Height;
            ((RadPopupOpeningEventArgs)args).CustomLocation = mccbScreenLocation;
        }

        private void Form1_Load(object sender, EventArgs e)
        {

        }
    }
}
